unit VaxCall;

interface

  uses

  System.Classes,
  VaxDefine;

type TVaxCall = class

  public
  constructor Create(); reintroduce; overload;
  destructor Destroy(); override;

  public
  procedure OnIncomingCall(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String; sToPeerName: String; var bProcessed: Boolean);

  private
  procedure AdjustVoiceType(nSessionId: Integer; bIsInboundCall: Boolean; sPeerName: String);

end;

implementation

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  Uses VaxUser, VaxServerSIP, VaxServerCOM;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  constructor TVaxCall.Create();
  begin
  end;

  destructor TVaxCall.Destroy();
  begin
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxCall.OnIncomingCall(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String; sToPeerName: String; var bProcessed: Boolean);
  begin

    bProcessed := False;

    if((Length(sDialNo) = 0) Or (Length(sToPeerName) = 0)) Then
      Exit();

    if(TVaxServerSIP.mVaxSIP.AcceptCallSession(nSessionId, '', '', sDialNo, sToPeerName, '') = False) then
    begin
      TVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, 'Not Found');
      Exit();
    end;

    AdjustVoiceType(nSessionId, True, sFromPeerName);
    AdjustVoiceType(nSessionId, False, sToPeerName);

    //TVaxServerSIP.mVaxSIP.DetectDigitDTMF(nSessionId, TVaxServerCOM.VAX_CALL_CHANNEL_ZERO, TVaxServerCOM.VAX_DTMF_TYPE_RFC2833, True, 2000);
    //TVaxServerSIP.mVaxSIP.RecordWaveStartToCallSession(nSessionId, TVaxServerCOM.VAX_CALL_CHANNEL_ZERO, 'Record.wav');

    bProcessed := True;

  end;

  procedure TVaxCall.AdjustVoiceType(nSessionId: Integer; bIsInboundCall: Boolean; sPeerName: String);
  var
    nChannelId: Integer;
    nVoiceType: Integer;
  begin

    if (bIsInboundCall = True) Then
      nChannelId := TVaxServerCOM.VAX_CALL_CHANNEL_ZERO
    else
      nChannelId := TVaxServerCOM.VAX_CALL_CHANNEL_ONE;

    nVoiceType := TVaxUser.GetVoiceTypeId(sPeerName);

    // Admin-Type can only listen to Normal-Type's voice, so adjust voice type from Admin-Type to User-Type. User-Type can speak and listen (both) to Normal-Type.
    // Admin-Type (voice) can be used in call-center for training sessions or stealth listening.

    if(nVoiceType = TVaxServerCOM.VAX_AUDIO_TYPE_ADMIN) Then
      nVoiceType := TVaxServerCOM.VAX_AUDIO_TYPE_USER;

    TVaxServerSIP.mVaxSIP.AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceType);

  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

end.

