unit VaxCallPickUp;

Interface
Uses

  System.Classes, SysUtils,
  StoreCallPickUp;

type TVaxCallPickUp = class

  public
  constructor Create();

  public
  class function AddCallPickUpGroup(sGroupName: String; objMemberList: TStringList): Boolean; static;
  class procedure RemoveCallPickUpGroup(sGroupName: String); static;
  class procedure LoadCallPickUpGroup(); static;

end;


implementation

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  Uses VaxServerSIP, VaxServerCOM;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  constructor TVaxCallPickUp.Create();
  begin
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  class function TVaxCallPickUp.AddCallPickUpGroup(sGroupName: String; objMemberList: TStringList): Boolean;
  var
    sMemberName: String;
  begin

    RemoveCallPickUpGroup(sGroupName);

    if((TVaxServerSIP.mVaxSIP.IsInitialized() = False) or (Length(sGroupName) = 0)) Then
      Exit(False);

    if(TVaxServerSIP.mVaxSIP.AddCallPickUpGroup(sGroupName) = False) Then
      Exit(False);

    for sMemberName in objMemberList do
    begin
      TVaxServerSIP.mVaxSIP.AddCallPickUpGroupMember(sGroupName, sMemberName);
    end;

    TStoreCallPickUp.AddGroup(sGroupName, objMemberList);
    Result := True;

  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  class procedure TVaxCallPickUp.RemoveCallPickUpGroup(sGroupName: String);
  begin

    if((TVaxServerSIP.mVaxSIP.IsInitialized() = False) or (Length(sGroupName) = 0)) Then
      Exit();

    TVaxServerSIP.mVaxSIP.RemoveCallPickUpGroup(sGroupName);
    TStoreCallPickUp.RemoveGroup(sGroupName);

  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  class procedure TVaxCallPickUp.LoadCallPickUpGroup();
  var
    sGroupName: string;
    objListNameAll: TStringList;
    objMemberList: TStringList;
  begin

    if(TVaxServerSIP.mVaxSIP.IsInitialized() = False) Then
      Exit();

    objListNameAll := TStringList.Create();
    TStoreCallPickUp.GetGroupNameAll(objListNameAll);

    if(objListNameAll.Count = 0) Then
      Exit();

    objMemberList := TStringList.Create();

    for sGroupName in objListNameAll do
    begin
      TStoreCallPickUp.GetGroup(sGroupName, objMemberList);
      AddCallPickUpGroup(sGroupName, objMemberList);
    end;

  end;

end.
