unit VaxQueueList;

interface

uses
  System.SysUtils, System.Classes,
  VaxHashText;

  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////

type TQueueDetails = class(TVaxHashTextData)

  public
  m_nMusicWaveId: Integer;
  m_nDialToneWaveId: Integer;

end;

  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////

type TVaxQueueList = class

  m_objQueueList: TVaxHashText;

  public
  constructor Create();
  destructor Destroy(); override;

  public
  procedure AddQueue(sQueueName: String; nMusicWaveId: Integer; nDialToneWaveId: Integer);
  procedure RemoveQueue(sQueueName: string);

  function GetQueueMusicId(sQueueName: string): Integer;
  function GetQueueDialToneId(sQueueName: string): Integer;

end;

implementation

  constructor TVaxQueueList.Create();
  begin
    m_objQueueList := TVaxHashText.Create();
  end;

  destructor TVaxQueueList.Destroy();
  begin
    m_objQueueList.ClearAll();
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxQueueList.AddQueue(sQueueName: String; nMusicWaveId: Integer; nDialToneWaveId: Integer);
  var
    objDetails: TQueueDetails;
  begin
    objDetails :=  TQueueDetails.Create();

    objDetails.m_nMusicWaveId := nMusicWaveId;
    objDetails.m_nDialToneWaveId := nDialToneWaveId;

    m_objQueueList.AddData(sQueueName, objDetails);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxQueueList.RemoveQueue(sQueueName: string);
  begin
    m_objQueueList.RemoveData(sQueueName);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxQueueList.GetQueueMusicId(sQueueName: string): Integer;
  var
    objDetails: TQueueDetails;
  begin
    objDetails := TQueueDetails(m_objQueueList.FindData(sQueueName));
    if(objDetails = nil) Then Exit(-1);

    Exit(objDetails.m_nMusicWaveId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxQueueList.GetQueueDialToneId(sQueueName: string): Integer;
  var
    objDetails: TQueueDetails;
  begin
    objDetails := TQueueDetails(m_objQueueList.FindData(sQueueName));
    if(objDetails = nil) Then Exit(-1);

    Exit(objDetails.m_nDialToneWaveId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

end.
